=== debian/changelog ===
ros-iron-cartographer (2.0.9002-5jammy) jammy; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 20 Apr 2023 03:59:46 -0000

ros-iron-cartographer (2.0.0-5jammy) jammy; urgency=high

  https://github.com/cartographer-project/cartographer/compare/1.0.0...2.0.0

 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 08 Mar 2021 16:00:00 -0000

ros-iron-cartographer (1.0.0-5jammy) jammy; urgency=high

  https://github.com/googlecartographer/cartographer/compare/0.3.0...1.0.0

 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 31 May 2018 16:00:00 -0000

ros-iron-cartographer (0.3.0-5jammy) jammy; urgency=high

  https://github.com/googlecartographer/cartographer/compare/0.2.0...0.3.0

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 22 Nov 2017 16:00:00 -0000

ros-iron-cartographer (0.2.0-5jammy) jammy; urgency=high

  https://github.com/googlecartographer/cartographer/compare/0.1.0...0.2.0

 -- Chris Lalancette <clalancette@openrobotics.org>  Sun, 18 Jun 2017 16:00:00 -0000

ros-iron-cartographer (0.1.0-5jammy) jammy; urgency=high

  * First unstable development release

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 17 May 2017 16:00:00 -0000
